
var fileListItemTemplate = ''
	+'<li class="document_li_liststyle">																'
	// +'	<input class="document_checkbox" type="checkbox">	'
	+'	<img class="document_img_liststyle" src="/loadImage/{imgpath}" onclick="downloadFile(\'{path}\')">	'
	+'	<a title="{name}" class="document_a_liststyle" href="javascript:downloadFile(\'{path}\')">{name}</a>'
	// +'	<a title="{name}" class="document_a_liststyle">{name}</a>'
	+'	<input class="document_input_liststyle" type="button" value="下载" onclick="downloadFileByButton(\'{path}\', this)">	'
	+'</li>';
	
var dirListItemTemplate = ''
	+'<li class="document_li_liststyle">																'
	// +'	<input class="document_checkbox" type="checkbox">	'
	+'	<img class="document_img_liststyle" src="/loadImage/folder" onclick="enterFolder(\'{path}\')">	'
	+'	<a title="{name}" class="document_a_liststyle" href="javascript:enterFolder(\'{path}\')">{name}</a>'
	+'	<input class="document_input_liststyle" type="button" value="进入" onclick="enterFolder(\'{path}\')">	'
	+'</li>';
	
var newFolderTemplate = ''
	+'<li class="upload_li_liststyle">																'
	+'	<a>请输入文件夹名：</a>'
	+'	<input type="text" class="upload_a_left" id="newFolderName" onkeydown="if(event.keyCode == 13) confirmName();">'
	+'	<input type="button" value="确认" onclick="confirmName()">	'
	+'	<input type="button" value="取消" onclick="cancelName()">	'
	+'</li>';
	
var renameTemplate = ''
	+'<li class="upload_li_liststyle">																'
	+'	<a>请输入新文件名：</a>'
	+'	<input type="text" class="upload_a_left" id="newFolderName" onkeydown="if(event.keyCode == 13) confirmRename();">'
	+'	<input type="button" value="确认" onclick="confirmRename()">	'
	+'	<input type="button" value="取消" onclick="cancelName()">	'
	+'</li>';


$(document).ready(function(){
	loadPath = "";
	updateCurrentPath();
	loadFileList();
	loadTitle();
	
	initXhr();
});

function hideAdminOperation(){
	$("#btnUpload").hide();
	$("#btnNewFolder").hide();
	$("#btnDelete").hide();
	$("#btnRename").hide();
}

function setStyle(){
	if(viewMode == "grid"){
		$("#document_box li").addClass("document_li_gridstyle");
		$("#document_box li img").addClass("document_img_gridstyle");
		$("#document_box li a").addClass("document_a_gridstyle");
		$("#document_box li input").addClass("document_input_gridstyle");
	}
	else if(viewMode == "list"){
		$("#document_box li").removeClass("document_li_gridstyle");
		$("#document_box li img").removeClass("document_img_gridstyle");
		$("#document_box li a").removeClass("document_a_gridstyle");
		$("#document_box li input").removeClass("document_input_gridstyle");
	}
}

function rename(){
	var pathlist = [];
	
	$(".document_checkbox").each(function(){
		if (true == $(this).prop("checked")) {
			var nextElement = $(this).next().next();
			pathlist.push(nextElement.text());
		}
	});
	
	if(pathlist.length != 1){
		showStatus("请选择一个文件", 2000);
		return;
	}
	
	var html = renameTemplate;
	$("#upload_box").empty();
	$("#upload_box").append(html);
	
	var oldname = pathlist[0];
	if(oldname.lastIndexOf(".") != -1){
		extName = oldname.substring(oldname.lastIndexOf("."));
		oldname = oldname.substring(0, oldname.lastIndexOf("."));
	}
	else{
		extName = "";
	}
	
	$("#newFolderName").val(oldname);
	
	$("#newFolderName").focus();
	$("#newFolderName").select();
	
	$(".document_checkbox").prop("disabled", true);
}

function confirmRename(){
	var name = $("#newFolderName").val();
	
	if(name == ""){
		alert("文件名不能为空！");
		return;
	}
	
	if(name[0] == '.'){
		alert("文件名不能以.开头");
		return;
	}
	
	var pathlist = [];
	
	$(".document_checkbox").each(function(){
		if (true == $(this).prop("checked")) {
			var nextElement = $(this).next().next();
			pathlist.push(encodeURI(nextElement.text()));
		}
	});
	
	if(pathlist.length != 1){
		showStatus("请选择一个文件", 2000);
		return;
	}
	
	pathlist.push(encodeURI(name+extName));
	
	var pathString = pathlist.join("],[");
	
	$.ajax({
		type: 'POST',
		url: '/renameFile/'+encodeURI(loadPath),
		data: pathString,
		success: function(response){
			var result = eval('(' + response + ')');	// parse JSON
			var msg;
			if(result["code"] != 0){
				if(result["code"] == 1){
					msg = "重命名失败";
				}
				else if(result["code"] == 2){
					msg = "已存在此名称";
				}
				else if(result["code"] == 3){
					msg = "文件名含有非法字符";
				}
				else if(result["code"] == 4){
					msg = "文件名过长";
				}
				showStatus(msg, 2000);
				return;
			}
			
			if(result["code"] == 0){
				msg = "重命名成功";
			}
			showStatus(msg, 2000);
			window.setTimeout(loadFileList, 2000);
		},
		error: function(){
			confirm(OPERATION_ERR);
			location.reload();
		}
	});
}

function newFolder(){
	var html = newFolderTemplate;
	$("#upload_box").empty();
	$("#upload_box").append(html);
	$("#newFolderName").focus();
}

function confirmName(){
	var name = $("#newFolderName").val();
	
	if(name == ""){
		alert("文件夹名不能为空！");
		return;
	}
	
	var path;
	if(loadPath == ""){
		path = "/newFolder/"+name;
	}
	else{
		path = "/newFolder/"+loadPath+"/"+name;
	}
	$.ajax({
		type: 'GET',
		url: encodeURI(path),
		success: function(response){
			var result = eval('(' + response + ')');	// parse JSON
			var code = result["code"];
			var msg = result["msg"];
			showStatus(msg, 2000);
			window.setTimeout(loadFileList, 2000);
		},
		error: function(){
			confirm(OPERATION_ERR);
			location.reload();
		}
	});
}

function cancelName(){
	$("#upload_box").empty();
	$(".document_checkbox").prop("disabled", false);
}

// checkbox
$("#checkAllBtn").bind("click", function () {
	if($("#checkAllBtn").val() == "全选"){
		$(".document_checkbox").prop("checked", true);
		$("#checkAllBtn").val("全不选");
	}
	else{
		$(".document_checkbox").prop("checked", false);
		$("#checkAllBtn").val("全选");
	}
});