
var editMode = "finish";

var fileListItemTemplate = ''
	+'<li class="column">'
	+'	<div class="document_info">'
	+'		<img class="document_img" src="/loadImage/{imgpath}" onclick="downloadFile(\'{path}\')">'
	+'		<a title="{name}" class="document_name" href="javascript:downloadFile(\'{path}\')">{name}</a>'
	+'		<a title="{name}" class="document_no_link">{name}</a>'
	+'		<img class="document_arrow document_arrow_down" src="./arrow_down.png">'
	+'		<img class="document_arrow document_arrow_up" src="./arrow_up.png">'
	+'		<input class="document_checkbox" type="checkbox">'
	+'	</div>'
	+'	<div class="document_btn_box">'
	+'		<div class="document_btn" onclick="downloadFile(\'{path}\')">'
	+'			<img src="./download.png">'
	+'			<span><a>下载</a></span>'
	+'		</div>'
	+'		<div class="clearfix"></div>'
	+'	</div>'
	+'</li>'

var dirListItemTemplate = ''
	+'<li class="column">'
	+'	<div class="document_info">'
	+'		<img class="document_img" src="/loadImage/folder" onclick="enterFolder(\'{path}\')">'
	+'		<a title="{name}" class="document_name" href="javascript:enterFolder(\'{path}\')">{name}</a>'
	+'		<a title="{name}" class="document_no_link">{name}</a>'
	+'		<input class="document_checkbox" type="checkbox">'
	+'	</div>'
	+'</li>'

var newFolderTemplate = ''
	+'<li class="new_folder">																'
	+'	<input type="text" class="new_folder_input" id="newFolderName" onkeydown="if(event.keyCode == 13) confirmName();" placeholder="请输入文件夹名：">'
	+'	<input type="button" class="new_folder_btn new_folder_confirm" value="确认" onclick="confirmName()">	'
	+'	<input type="button" class="new_folder_btn new_folder_cancel" value="取消" onclick="cancelName()">	'
	+'</li>';

$(document).ready(function(){
	var editMode = "finish";
	showDownloadAppBar();
	
	updateCurrentPath();
	loadFileList();
	loadTitle();
	
	initXhr();
	
	$(window).scroll(
		function(){
			if($(window).scrollTop()>64){
				$("#header").css({"top":"-3em"});
				$("#download").css({"bottom":"-3em"});
				$("#nav").css({"top":"0"});
				}
			else{
				$("#header").css({"top":"0em"});
				$("#download").css({"bottom":"0em"});
				$("#nav").css({"top":"3em"});
			}
		}
	)
});

function hideAdminOperation(){
	// 隐藏新建文件夹和上传文件，看图模式的按键加宽
	$("#btnNewFolder").remove();
	$("#btnUpload").remove();
	$(".nav_btn").css({"width":"100%"});
	
	// 隐藏底部的删除键
	$("#btnDeleteBottom").remove();
}

function resetDocumentBtn(){
	$(".document_arrow_up").hide();
	$(".document_arrow_down").show();
	$(".document_btn_box").hide();
}

function changeEditMode(){
	if(editMode == "edit"){
		editMode = "finish";
		$("#btnEdit").val("批量编辑")
		$(".document_arrow_down").show();
		$(".document_checkbox").prop("checked",false);
		$(".document_checkbox").hide();	
		$(".main_btn_box").hide();
		$("#modeButton").show();
		$("#checkAllButton").hide();
	}
	else if(editMode == "finish"){
		editMode = "edit"
		$("#btnEdit").val("完成编辑")
		resetDocumentBtn()
		$(".document_arrow_down").hide();
		$(".document_checkbox").show();
		$("#modeButton").hide();
		$("#checkAllButton").show();
	}
}
	
$("#document_box").on("click", "li .document_info .document_arrow_down",
	function(){
		resetDocumentBtn()
		$(this).hide();
		$(this).siblings(".document_arrow_up").show();
		$(this).parent().siblings(".document_btn_box").show();
	}
);

$("#document_box").on("click", "li .document_info .document_arrow_up",
	function(){
		$(this).hide();
		$(this).siblings(".document_arrow_down").show();
		$(this).parent().siblings(".document_btn_box").hide();
	}
);

// delete
$("#document_box").on("click", "li .document_btn_box .document_btn.delete_btn",
	function(){
		resetDocumentBtn();
		var e = $(this).parent().siblings(".document_info");
		var name = e.children(".document_name").text();
		
		var r = confirm("是否删除 "+name);
		if(r){
			name = encodeURI(name);
			$.ajax({
				type: 'POST',
				url: '/deleteFiles/'+encodeURI(loadPath),
				data: name,
				success: function(response){
					var result = eval('(' + response + ')');	// parse JSON
					alert(result["result"]+"个文件已删除");
					loadFileList();
				},
				error: function(){
					confirm(OPERATION_ERR);
					location.reload();
				}
			});
		}
		
	}
);

// rename
var fullOldname;
$("#document_box").on("click", "li .document_btn_box .document_btn.rename_btn",
	function(){
		resetDocumentBtn();
		$(".document_arrow_down").hide();
		var e = $(this).parent().siblings(".document_info");
		fullOldname = e.children(".document_name").text();
		var oldname = fullOldname;
		
		e.children(".document_name").hide();
		e.siblings(".rename").show();
		if(fullOldname.lastIndexOf(".") != -1){
			extName = fullOldname.substring(fullOldname.lastIndexOf("."));
			oldname = fullOldname.substring(0, fullOldname.lastIndexOf("."));
		}
		else{
			extName = "";
		}
		
		var renameDiv = e.siblings(".rename");
		renameDiv.children(":text").val(oldname);
		renameDiv.children(":text").focus();
		renameDiv.children(":text").select();
	}
);

function confirmRename(id){
	var name = $(id).parent().children(":text").val();
	
	if(name == ""){
		alert("文件夹名不能为空！");
		return;
	}
	
	if(name[0] == '.'){
		alert("文件名不能以.开头");
		return;
	}
	
	var pathlist = [];
	
	pathlist.push(encodeURI(fullOldname));
	
	if(pathlist.length != 1){
		showStatus("请选择一个文件", 2000);
		return;
	}
	
	pathlist.push(encodeURI(name+extName));
	
	var pathString = pathlist.join("],[");
	
	$.ajax({
		type: 'POST',
		url: '/renameFile/'+encodeURI(loadPath),
		data: pathString,
		success: function(response){
			var result = eval('(' + response + ')');	// parse JSON
			var msg;
			if(result["code"] != 0){
				if(result["code"] == 1){
					msg = "重命名失败";
				}
				else if(result["code"] == 2){
					msg = "已存在此名称";
				}
				else if(result["code"] == 3){
					msg = "文件名含有非法字符";
				}
				else if(result["code"] == 4){
					msg = "文件名过长";
				}
				showStatus(msg, 2000);
				return;
			}
			
			if(result["code"] == 0){
				msg = "重命名成功";
			}
			showStatus(msg, 2000);
			window.setTimeout(loadFileList, 2000);
		},
		error: function(){
			confirm(OPERATION_ERR);
			location.reload();
		}
	});
}

function cancelRename(elementCancel){
	$(".document_arrow_down").show();
	$(elementCancel).parent().siblings(".document_info").children(".document_name").show();
	$(elementCancel).parent().hide();
}

function appCancelRename(){
	var e = $(".rename_cancel:visible")[0];
	cancelRename(e);
}

// new folder
function newFolder(){
	scroll(0,0);	//回到顶部
	var html = newFolderTemplate;
	$("#upload_box").empty();
	$("#upload_box").append(html);
	$("#newFolderName").focus();
}

function confirmName(){
	var name = $("#newFolderName").val();
	
	if(name == ""){
		alert("文件夹名不能为空！");
		return;
	}
	
	var path;
	if(loadPath == ""){
		path = "/newFolder/"+name;
	}
	else{
		path = "/newFolder/"+loadPath+"/"+name;
	}
	$.ajax({
		type: 'GET',
		url: encodeURI(path),
		success: function(response){
			var result = eval('(' + response + ')');	// parse JSON
			var code = result["code"];
			var msg = result["msg"];
			if(code != 0){
				showStatus(msg, 2000);
				return;
			}
			
			showStatus(msg, 2000);
			window.setTimeout(loadFileList, 2000);
		},
		error: function(){
			confirm(OPERATION_ERR);
			location.reload();
		}
	});
}

function cancelName(){
	$("#upload_box").empty();
}

// checkbox
$("#document_box").on("change", "li .document_info .document_checkbox",
	function(){
		checkAllButtonMode()
	}
)
var checkMode = "none"
function changeCheckMode(){
	if(checkMode == "none"){
		$(".document_checkbox").prop("checked",true);
	}
	else if(checkMode == "all"){
		$(".document_checkbox").prop("checked",false);	
	}
	checkAllButtonMode()	
}

function checkAllButtonMode(){
	var chd = $(".document_checkbox:checked").length;
	$(".main_btn_box").show();
	if(chd == 0){
		checkMode = "none"
		$("#checkAllButton").val("全选")
		$(".main_btn_box").hide();
	}
	else if(chd == $(".document_checkbox").length){
		checkMode = "all"
		$("#checkAllButton").val("全不选")
	}	
}

$("#btnUpload").click(
	function(){
		// $(".column_upload").toggle();	
		chooseFile();
	}
)

// change style
function setStyle(){
	if(viewMode == "grid"){
		$(".column").addClass("column_gridstyle");
		$(".document_info").addClass("document_info_gridstyle");
		$(".document_img").addClass("document_img_gridstyle");
		$(".document_name").addClass("document_name_gridstyle");
		$(".document_arrow").addClass("document_arrow_gridstyle");
		$(".document_btn_box").addClass("document_btn_box_gridstyle");
		$(".document_checkbox").addClass("document_checkbox_gridstyle");
		$(".column:even").addClass("clearfix");
		$(".rename_btn").hide();
		if(permission == "GUEST"){
			// 部分分享时，只有一个键
			$(".document_btn").css({"width":"100%"});
		}
		else{
			$(".document_btn").css({"width":"50%"});
		}
		
		$(".document_name").hide();
		$(".document_no_link").show();
	}
	else if(viewMode == "list"){
		$(".column").removeClass("column_gridstyle");
		$(".document_info").removeClass("document_info_gridstyle");
		$(".document_img").removeClass("document_img_gridstyle");
		$(".document_name").removeClass("document_name_gridstyle");
		$(".document_arrow").removeClass("document_arrow_gridstyle");
		$(".document_btn_box").removeClass("document_btn_box_gridstyle");
		$(".document_checkbox").removeClass("document_checkbox_gridstyle");
		$(".column:even").removeClass("clearfix")
		$(".rename_btn").show();
		$(".document_name").show();
		$(".document_no_link").hide();
	}
}

// 隐藏上面的title和下面的下载app的bar
function showDownloadAppBar(){
	if(isIPhone){
		// 苹果手机不显示
	}
	else{
		$("#header").css({"top":"0"});
		$("#download").css({"bottom":"0"});
		$("#nav").css({"top":"3em"});
		$("#main").css({"margin-top":"6em"});
	}
}
